// https://adventofcode.com/2020/day/2

//#pragma target(atarixl)

#include <stdio.h>
#include <conio.h>

extern char *passwords;

char strtouc(char *str, char **endptr);

void main () {
    clrscr();
    unsigned int valid_a = 0, invalid_a = 0;
    unsigned int valid_b = 0, invalid_b = 0;
    unsigned int total = 0;
    char *pwd = passwords;
    while(*pwd) {
        // Parse the first number in the policy        
        char min = strtouc(pwd, &pwd);
        pwd++;
        char max = strtouc(pwd, &pwd);
        pwd++;
        char ch = *pwd;
        pwd +=3; // skip char and ": "
        // Count whether char at pos min & max matches ch
        char count_b = 0;
        if(pwd[min-1]==ch) count_b++;
        if(pwd[max-1]==ch) count_b++;
        //printf("[%u] min: %u max:%u char:%c count:%u\n", total, min, max, ch, count_b);
        // Count number of chars in the password matches ch 
        char count_a = 0;
        while(*pwd) {
            if(*pwd==ch) count_a++;
            pwd++;
        }    
        //printf("[%u] min: %u max:%u char:%c count:%u\n", idx, min, max, ch, count);
        // Test rule A: 
        if(count_a>=min && count_a<=max)
            valid_a++;
        else
            invalid_a++;
        // Test rule A: 
        if(count_b==1)
            valid_b++;
        else
            invalid_b++;
        total++;
        pwd++;
    }
    printf("rule a valid: %u invalid:%u total:%u\n", valid_a, invalid_a, total);
    printf("rule b valid: %u invalid:%u total:%u\n", valid_b, invalid_b, total);
    for(;;) ;
}

// Converts the string pointed to, by the argument str to an unsigned char (unsing base 10)
// Modifies *endptr to point to the first unparseable character
char strtouc(char *str, char **endptr) {
    char val = 0;
    char c = *str;
    while(c>='0' && c<='9') {
        val = val*10;
        val += c-'0';
        str++;
        c = *str;
    }
    *endptr = str;
    return val;
}

// Use one huge string since array of strings is not currently supported
char *passwords = 
  "4-6 b: bbbdbtbbbj" "\x00"
  "1-6 g: ggvggbgggstg" "\x00"
  "1-4 s: lssss" "\x00"
  "13-14 v: hvvcvvvvvvvvvsvvv" "\x00"
  "3-5 m: lcmmm" "\x00"
  "3-4 t: stht" "\x00"
  "5-6 b: dbkbhb" "\x00"
  "4-7 p: ppfppppq" "\x00"
  "4-5 j: jjjjj" "\x00"
  "3-12 s: sskssssssssss" "\x00"
  "14-15 z: zrndzbmrzzpzzqzj" "\x00"
  "12-18 l: tllllllllllllplllbl" "\x00"
  "8-10 b: bdbvqbtbrb" "\x00"
  "1-3 c: tcqccc" "\x00"
  "1-2 n: nbnj" "\x00"
  "5-7 c: ccccccccc" "\x00"
  "9-10 l: hpmslrlgll" "\x00"
  "6-9 n: nnnnnnnnb" "\x00"
  "6-10 r: rmzjlrsxkbw" "\x00"
  "6-8 r: bzqnnrrrj" "\x00"
  "4-14 c: mfffvcbtchzrqcn" "\x00"
  "1-6 f: ffffffffffffff" "\x00"
  "2-5 f: wxtkf" "\x00"
  "8-12 b: rdcbbjbzbbpb" "\x00"
  "8-18 d: ddtdddddddwvdfdsdd" "\x00"
  "5-8 s: sssmsgpgszms" "\x00"
  "6-11 x: xxxxxvxxxxxt" "\x00"
  "17-18 n: jhrnnzpxzngfqrntmnc" "\x00"
  "13-14 r: rrrmrrrrlrrshvrrr" "\x00"
  "4-5 h: hhhhrhh" "\x00"
  "8-10 d: dgwtdsxnncd" "\x00"
  "9-13 q: qqbpqmqgmqwqbqqqxcgq" "\x00"
  "2-5 g: gjjcpgg" "\x00"
  "6-12 t: ttttvttttttrtt" "\x00"
  "3-9 h: hhhhhhhhsh" "\x00"
  "15-16 p: ppppsppppppppppz" "\x00"
  "2-5 c: csccctcccc" "\x00"
  "11-14 p: pppppppppppppnp" "\x00"
  "8-9 j: jvbjjjjrjbjj" "\x00"
  "8-16 b: qklbmbntmvbhxplbbcb" "\x00"
  "12-13 j: jjjjsjmfjjjkhj" "\x00"
  "2-13 t: llckxhfmtznptndcsx" "\x00"
  "6-8 x: dxxxxvxxtt" "\x00"
  "3-4 d: ddht" "\x00"
  "3-4 t: ttdtt" "\x00"
  "11-12 r: rrrrrrrrrrrd" "\x00"
  "9-10 h: hhhhhhhhgh" "\x00"
  "3-16 h: hhhhhhhhhhhhhhnhhh" "\x00"
  "10-11 h: hxhhhdhhhsh" "\x00"
  "1-7 n: jnfnjnn" "\x00"
  "3-4 m: msmnpmpf" "\x00"
  "15-17 t: tpdtttgltvtttztlv" "\x00"
  "7-10 v: vvpsvpgjzvvvvjs" "\x00"
  "1-5 p: pxppg" "\x00"
  "2-7 w: jwhgkgvxcv" "\x00"
  "13-14 m: pxxmjznmrzdsbbmmfj" "\x00"
  "1-4 d: ddddd" "\x00"
  "14-16 r: rrrrrrrrrrrrrwrr" "\x00"
  "2-5 l: klbtzzlrlslgswhljtq" "\x00"
  "6-12 c: qccrcpccccccdccccc" "\x00"
  "2-18 l: llllllllvllllllllkll" "\x00"
  "18-20 z: zzzzzzzzszqzwzrzzzzn" "\x00"
  "5-16 c: cbccclcfcncvqztqc" "\x00"
  "7-11 m: fnwmtsmgpxncnr" "\x00"
  "6-7 h: hpjrhbhkshnchbhpph" "\x00"
  "11-12 s: ssssssssssps" "\x00"
  "6-9 s: jfsmmssssqz" "\x00"
  "1-15 l: llllllllllllllbll" "\x00"
  "2-6 g: gggggwgggpggggggg" "\x00"
  "6-9 j: jjjpjjjjn" "\x00"
  "9-13 n: nnnnnnnnnnnnnn" "\x00"
  "10-13 t: cgntllxnvpkjwxtght" "\x00"
  "2-11 f: xcftbcdcndkgm" "\x00"
  "10-13 j: jjjjjjjjjjjjvj" "\x00"
  "9-17 f: rfrffnsffxqflbffvv" "\x00"
  "6-11 k: kkkkkrwkqckmk" "\x00"
  "5-7 q: zfqqqqqn" "\x00"
  "12-13 c: cfcccvccccckccccv" "\x00"
  "5-15 z: xhzzzzzzzzfzzknzz" "\x00"
  "18-19 f: jkfksvmfjbdffffffff" "\x00"
  "8-11 h: hhhhmhhkhsfdg" "\x00"
  "14-16 s: ssssssdjssssssssssss" "\x00"
  "15-16 t: jtmjhsxqqmmthmtttm" "\x00"
  "5-7 h: hkbjhjhh" "\x00"
  "2-6 n: knprnfnfhhrcnk" "\x00"
  "3-4 w: snwd" "\x00"
  "5-11 w: wwwwnwwwwwwwwwwww" "\x00"
  "2-12 k: bkqjghpktfsk" "\x00"
  "14-15 v: vvvsvvvvvvvvvxv" "\x00"
  "8-9 w: fxwwwwwscwl" "\x00"
  "9-15 c: sbjvvsmdvqknbccxxx" "\x00"
  "6-15 t: tpwjtdnnldthxvn" "\x00"
  "13-15 t: tttttrzmzttjttt" "\x00"
  "3-11 m: mmvmlmmmwfmjx" "\x00"
  "13-14 s: gskssssssscssssqjssl" "\x00"
  "5-10 l: bfnmqlldllp" "\x00"
  "17-18 q: qkwqqqqqqqqqqqrqqqqq" "\x00"
  "2-5 r: rsvrrq" "\x00"
  "3-4 j: jjjdj" "\x00"
  "3-4 m: mtmk" "\x00"
  "8-9 k: vsvkvkrkc" "\x00"
  "10-12 t: ttttttcttttgttt" "\x00"
  "3-4 n: trzw" "\x00"
  "5-11 q: qqmpsqbxkqq" "\x00"
  "13-15 s: sqsssnmwqszfsmv" "\x00"
  "5-6 b: bbbbzvb" "\x00"
  "5-13 p: pjjhpnqpzpmpfpfp" "\x00"
  "4-5 l: mgnwlrw" "\x00"
  "1-7 k: fkzxwkj" "\x00"
  "1-10 q: qgxqqqqqqg" "\x00"
  "8-9 s: ssqssssfss" "\x00"
  "7-8 c: xxcscclccdvcmqcc" "\x00"
  "2-6 d: xdlmzdzxrpmlnt" "\x00"
  "3-9 s: sssssnssgbs" "\x00"
  "7-10 h: sblrrhqrhh" "\x00"
  "3-5 n: xnndnnnfnw" "\x00"
  "9-10 l: vllllqlllhllljxlp" "\x00"
  "2-5 d: ddxzbxk" "\x00"
  "10-14 m: mmmmmmmmmmdmmmmsmmm" "\x00"
  "1-2 f: ffffw" "\x00"
  "14-15 g: wdjhplhrbcxdgpnt" "\x00"
  "1-2 l: klllllll" "\x00"
  "10-11 k: ckkhkkvkkkmkkjkwkkwk" "\x00"
  "7-9 f: ffrhdvftfpjfqffhnfsf" "\x00"
  "4-5 c: kkjksrmkccg" "\x00"
  "5-9 r: rrrrhrrrrr" "\x00"
  "5-6 p: pppppth" "\x00"
  "4-10 t: kpfwzjtchtbndblrvst" "\x00"
  "1-5 l: mllllllnllll" "\x00"
  "13-16 r: rrrvrrrrrrrrzrrg" "\x00"
  "17-18 x: xxfxxxxxxxxsxxxxxsxx" "\x00"
  "8-11 w: rwbnqrngcvpgwwww" "\x00"
  "4-8 z: zzzzzzzzzz" "\x00"
  "4-9 b: bbvvbbbbr" "\x00"
  "2-5 x: qlfhxkx" "\x00"
  "3-8 t: wvptttttttt" "\x00"
  "1-3 m: hmmmmqmm" "\x00"
  "17-19 h: nhhhdvhnhrhhhhnhmdh" "\x00"
  "11-12 s: psszbdpsgfks" "\x00"
  "6-7 s: sssssshs" "\x00"
  "10-15 l: mnkdvnvmxljjtggwcl" "\x00"
  "1-13 j: qjjjjjjjjjjjdj" "\x00"
  "4-9 l: jxvkwhlmlhdtgwvgsdzz" "\x00"
  "5-9 c: ccfghhccccgc" "\x00"
  "10-11 v: vvvvvvvvvvv" "\x00"
  "7-8 t: cntwzshkzvmrnnkr" "\x00"
  "1-11 l: tllllllltllll" "\x00"
  "15-17 l: lllglvctrvllzkllt" "\x00"
  "3-5 n: ncnnp" "\x00"
  "2-3 q: jsqqh" "\x00"
  "4-10 h: hhhhhhhhhvh" "\x00"
  "16-18 b: bbnbbbbbtbbkktbbzdr" "\x00"
  "4-6 g: kbggdhgggggggggggfc" "\x00"
  "12-13 p: cpvcppqpplwpt" "\x00"
  "5-10 h: fvhhbrhpghchhhhhh" "\x00"
  "2-5 b: bbvzn" "\x00"
  "14-15 x: xxxbxnwxxxxzxxh" "\x00"
  "13-15 n: nnfgdglfnntnjqn" "\x00"
  "2-4 c: cfccc" "\x00"
  "3-5 v: vrvvzdvv" "\x00"
  "17-19 v: vvvvvvvvvvvvvvvvvvsv" "\x00"
  "1-20 h: hhhhhhhhhhqhhhhhhhhh" "\x00"
  "4-15 q: qqqtqqqqqqqqqqqqlq" "\x00"
  "11-13 h: hhkhvhhhhwhgk" "\x00"
  "8-11 p: ppvppppppptspf" "\x00"
  "8-9 m: mmmpmmkmdmpkspmg" "\x00"
  "1-7 m: lcmvggm" "\x00"
  "6-12 v: tvfstvvpvzsvcv" "\x00"
  "8-9 n: nnnqnnwrrdzlmnwlznrn" "\x00"
  "1-5 s: msssms" "\x00"
  "1-3 v: vpdzvdvgv" "\x00"
  "6-9 g: drgrfggcg" "\x00"
  "6-16 x: djpxhxvncxfghsxx" "\x00"
  "1-3 b: sjbwwxbvtvbkt" "\x00"
  "6-8 c: cccccstccjhv" "\x00"
  "1-11 q: qqqpqqqqqqwqqq" "\x00"
  "9-11 m: vsbmmmmmmmqmmsm" "\x00"
  "2-7 g: gqggggggg" "\x00"
  "2-3 m: mrgvm" "\x00"
  "6-7 c: cccpcfcc" "\x00"
  "6-10 w: swbngwswnxnww" "\x00"
  "13-14 r: rrrrrrrrrrwrrgrdr" "\x00"
  "3-9 v: vctxhxtfvq" "\x00"
  "2-9 r: jrrcslgplcprlvgthg" "\x00"
  "2-3 n: hnnnsxclvdj" "\x00"
  "10-11 h: zrhghhqhgzh" "\x00"
  "15-18 z: zzzlzzzzzzzzpzqzpzzz" "\x00"
  "3-8 f: fffffrfl" "\x00"
  "1-4 l: rllllfl" "\x00"
  "1-2 n: nnnnnvtnv" "\x00"
  "17-19 z: zzzzzzzzzzzzzzzzzzqz" "\x00"
  "13-15 n: nnnznnnnnnznnnn" "\x00"
  "2-5 c: gcccncjmsncfcntjc" "\x00"
  "8-9 h: hhhhhhhhbpsfh" "\x00"
  "7-11 r: lzvvlbrgjgrr" "\x00"
  "5-11 x: xxxxqxxxxxxx" "\x00"
  "4-7 p: gqpkmppzpsmtzhfdfpl" "\x00"
  "3-4 j: jjdjdg" "\x00"
  "14-16 z: zzzzzzzgjzzzzpzf" "\x00"
  "1-2 n: nnnvnwnnnnh" "\x00"
  "4-5 z: jhzzz" "\x00"
  "5-7 k: kkkkkkf" "\x00"
  "8-18 z: khzzrzjzmzzvzzpcclm" "\x00"
  "5-10 m: kjrhwkhmsm" "\x00"
  "10-16 v: vvvvvvvvvvvvvvvwv" "\x00"
  "9-10 l: xhvjsmllkcdtldfxlw" "\x00"
  "8-10 p: ppjvppbpqhpwhppgbp" "\x00"
  "4-6 m: jlmkhm" "\x00"
  "1-3 k: gvpklkkkk" "\x00"
  "15-16 g: ggjggggvgmgtpgcg" "\x00"
  "1-4 j: jbjwj" "\x00"
  "1-3 x: xxxpxxdxxhfx" "\x00"
  "14-16 v: vxmhhdvvfjjqwhtv" "\x00"
  "6-7 l: lnkchzlwxlp" "\x00"
  "3-4 v: vvvcv" "\x00"
  "13-14 p: pbqpppppzbmppc" "\x00"
  "6-12 p: glqwzprpqbqf" "\x00"
  "6-12 l: lllllglllllll" "\x00"
  "8-9 n: nnsnnnndcn" "\x00"
  "6-8 p: prwppppp" "\x00"
  "1-10 q: dqqqqqqqqjq" "\x00"
  "12-16 w: kwtbdnjqmwwxhwcwswkl" "\x00"
  "11-14 r: rrnjghfrrrshlrq" "\x00"
  "2-14 w: vwbbvcvgnxdmxl" "\x00"
  "7-8 g: sqmggkgslkwlvggg" "\x00"
  "1-6 q: tqqqqqq" "\x00"
  "2-3 b: bbbr" "\x00"
  "7-9 b: jnwbswfpbn" "\x00"
  "4-5 n: nnlct" "\x00"
  "3-11 s: ssssssssssp" "\x00"
  "2-6 f: wjlpwf" "\x00"
  "5-10 g: gggghqgqgb" "\x00"
  "1-3 p: ppdg" "\x00"
  "4-7 j: pjnkjjljjj" "\x00"
  "1-2 v: ghmjzxmtxjxnv" "\x00"
  "6-14 k: klgdzfmgdwhqdkhcnzm" "\x00"
  "6-11 z: tgzpzzzzztc" "\x00"
  "2-12 b: cxsmjbdgdnrb" "\x00"
  "4-6 v: lxdvvh" "\x00"
  "3-8 l: pnpdnrll" "\x00"
  "7-8 m: mzmswvmmbxmzlmwhdvq" "\x00"
  "13-14 s: khzssssssssszsssss" "\x00"
  "10-18 d: dmfdlgcxdbzznbrlqn" "\x00"
  "13-14 j: jjjjjjjjjjjjdpjj" "\x00"
  "15-17 j: jjjjjjjjjwjsqjwjj" "\x00"
  "10-15 x: xxfxkzxxhxxxxxvxxw" "\x00"
  "7-14 c: wcccwcmmcccccxhcccc" "\x00"
  "2-7 z: zmzvfzlszr" "\x00"
  "7-8 k: jjkrklrkkv" "\x00"
  "8-9 r: rrrrrjrtz" "\x00"
  "2-3 w: tvws" "\x00"
  "1-5 b: bbbjm" "\x00"
  "1-2 q: tqqjf" "\x00"
  "5-10 j: wlgjghjhjljwtpcdkqwk" "\x00"
  "2-5 c: dzpkc" "\x00"
  "5-6 m: mbvmkm" "\x00"
  "4-15 k: stjkjvvxrmwdpkwsjqvc" "\x00"
  "6-9 h: hwkgjplmhxwgvnbhwh" "\x00"
  "12-13 z: zzzzzzzzzzzzz" "\x00"
  "7-8 q: qqqqqqqqq" "\x00"
  "2-5 c: clcwmccczclcccc" "\x00"
  "2-5 l: jlcgfbflklvpfqxtwgg" "\x00"
  "5-7 n: nnnnnnvnnnnnn" "\x00"
  "3-5 f: gfktfffqvgltsbff" "\x00"
  "10-16 p: jppbttppzpqppppp" "\x00"
  "2-3 m: zmdm" "\x00"
  "4-6 j: zsmtjjdnrpp" "\x00"
  "17-18 j: hvvmrkfnnkvrjtjhjj" "\x00"
  "12-15 d: dtddddddddtwxgld" "\x00"
  "8-12 r: rdzrwfgrmxwttknxz" "\x00"
  "6-7 s: rssbktxsgd" "\x00"
  "11-13 d: ddddmwddddxddndc" "\x00"
  "3-6 p: ppcpspfp" "\x00"
  "12-15 j: jjjjjjgjjjjcjlzj" "\x00"
  "8-12 v: tgjkwfbsxzzvvpmfs" "\x00"
  "6-7 z: trbfbdz" "\x00"
  "4-6 v: vvvvvpvv" "\x00"
  "8-16 p: pnvppdpjppppppph" "\x00"
  "8-9 z: lzzzzpdzk" "\x00"
  "1-4 t: qttzz" "\x00"
  "2-3 d: dhdd" "\x00"
  "5-8 m: mmmkmmxmkj" "\x00"
  "2-12 f: hfhzkwdmrlqvfkn" "\x00"
  "5-6 h: hhhhhph" "\x00"
  "14-15 b: bbbbxbbbbbbbbbh" "\x00"
  "2-3 v: vvcj" "\x00"
  "12-19 d: ddvdwwqdddcdtdmwdqp" "\x00"
  "3-4 s: ssjssssssss" "\x00"
  "2-6 c: wzzxqcdcnlgcph" "\x00"
  "11-12 j: jjdrcjzjkjcs" "\x00"
  "4-9 z: bzzzzzzxzz" "\x00"
  "2-8 b: gjbfkxhb" "\x00"
  "1-3 c: cpksst" "\x00"
  "1-5 h: hhjhh" "\x00"
  "14-15 j: jjjjjjjjjjjjjjr" "\x00"
  "8-9 n: pcndxcfknfbnnls" "\x00"
  "10-13 k: kkkqzkwbkkkrtn" "\x00"
  "4-5 r: rzrrrnrj" "\x00"
  "13-15 p: ppppppppppppppt" "\x00"
  "3-6 j: fjqqzzzjm" "\x00"
  "2-9 m: zmjhctkmf" "\x00"
  "5-6 s: ssmjss" "\x00"
  "3-4 c: jlfd" "\x00"
  "8-12 d: qbddfhnddzgvddddd" "\x00"
  "6-7 p: xfppppcppppxgp" "\x00"
  "8-13 s: sssssssfssssssss" "\x00"
  "13-17 g: xskktsjxlvgfxtzzgfj" "\x00"
  "2-4 q: qqtwfqqnkvbvbhzs" "\x00"
  "1-5 j: cjmjs" "\x00"
  "4-5 c: tvccnc" "\x00"
  "3-14 m: kkfhmnkkmztxtmn" "\x00"
  "11-15 x: xxxxxpxmxxvbxxxvx" "\x00"
  "9-11 l: nhgzwmmrkqhblnk" "\x00"
  "7-10 x: xxxxxdmxxxxxxxx" "\x00"
  "13-14 v: vvvvvvpvvvjvvcvv" "\x00"
  "16-17 n: nnnnqnnbnnnnnnnpn" "\x00"
  "3-4 j: jvjj" "\x00"
  "15-16 q: zlqsgvpztknqjqqwqvf" "\x00"
  "3-4 s: sssrsssdss" "\x00"
  "11-13 g: ggqggmggswggdk" "\x00"
  "1-4 t: jmtzttztqt" "\x00"
  "2-3 v: vvvv" "\x00"
  "11-13 g: cgjgxgggkgbggxg" "\x00"
  "4-6 g: ggggqlhgmz" "\x00"
  "8-15 g: prvxwzkvdhgkjlg" "\x00"
  "6-9 g: gggggnsjlg" "\x00"
  "12-14 p: mmvlpzkmpgtpvj" "\x00"
  "7-10 k: kkkxkkjkkkdkkkp" "\x00"
  "14-16 b: zmztqsrgvjjmswzkbnk" "\x00"
  "1-2 x: xxbxxxxhx" "\x00"
  "2-5 l: tlhsx" "\x00"
  "3-5 x: xxxxn" "\x00"
  "4-12 c: vdnmtmqwnxkcldc" "\x00"
  "4-8 x: xxxxjglx" "\x00"
  "5-13 s: vsssspszssssnsss" "\x00"
  "3-6 k: kkhkkkknb" "\x00"
  "3-5 t: pttqtwnprt" "\x00"
  "10-14 m: ttjqvzmgmmjqzkd" "\x00"
  "1-5 b: bbbbpbbb" "\x00"
  "10-15 d: wdjrhvfngdtlkdl" "\x00"
  "6-7 w: trxwdwww" "\x00"
  "2-4 n: snxqlgtsmdnnjgwrgmms" "\x00"
  "16-18 l: klslpljllqlcslqqll" "\x00"
  "4-7 t: tttwzttjt" "\x00"
  "9-10 f: ffffffffwf" "\x00"
  "8-15 h: trhgxjchhxvvhqp" "\x00"
  "8-12 w: wwwwwwwqwwwg" "\x00"
  "12-13 x: xxxxxxxxsffqlxx" "\x00"
  "5-7 k: kkkklkkkktkk" "\x00"
  "1-7 m: wkmmqmmhf" "\x00"
  "12-13 h: mhhchwhhhzhhcvh" "\x00"
  "7-11 k: kkkkkkwkkkgkk" "\x00"
  "4-6 l: hdlbll" "\x00"
  "8-12 v: fvvvvvvvrvvv" "\x00"
  "2-9 h: hzhhhhhhhhhhhhr" "\x00"
  "6-8 b: qbqjpbbbdsshv" "\x00"
  "2-3 h: hwhl" "\x00"
  "4-7 l: mdllxjgdw" "\x00"
  "3-9 f: rwffzfkpwbzp" "\x00"
  "3-5 t: ttnttt" "\x00"
  "7-10 c: mpcccpndqc" "\x00"
  "6-7 h: fhhhljh" "\x00"
  "2-7 v: pnvzcns" "\x00"
  "1-3 v: vvgv" "\x00"
  "5-9 s: ssssshsspsssssss" "\x00"
  "4-6 j: mjjjjq" "\x00"
  "5-14 h: hwbqghmvmmnvhhrqmj" "\x00"
  "5-6 s: wctjsh" "\x00"
  "7-8 s: sssscsjs" "\x00"
  "14-17 v: vvvvvvvvvvvvvvvvv" "\x00"
  "14-15 w: wxwwwwwwfwwwwsw" "\x00"
  "6-7 v: ksvvvlpvv" "\x00"
  "7-18 s: cssstsvsscshsstsss" "\x00"
  "5-6 b: zzwbpm" "\x00"
  "6-7 r: bvtmpkxspskr" "\x00"
  "6-7 v: lvxrvqv" "\x00"
  "15-17 c: ccccccccccccccccccc" "\x00"
  "8-12 r: ghxpwhxcqjrr" "\x00"
  "6-10 k: kzbcdkndqm" "\x00"
  "5-6 s: tpsxss" "\x00"
  "1-5 p: qlrlp" "\x00"
  "4-8 q: qqqkqqqz" "\x00"
  "7-11 v: vgvsxvwvlxv" "\x00"
  "2-5 b: bgkbb" "\x00"
  "3-18 j: jjsplxjxgqjfjrjxjjlx" "\x00"
  "6-10 k: kxkhkkjkkrvkkk" "\x00"
  "7-16 t: ttttttzttttttttbtttt" "\x00"
  "1-7 l: ptzptslrjgwlfgwq" "\x00"
  "8-10 v: vvqvvvvvvvv" "\x00"
  "3-5 z: zzzhz" "\x00"
  "6-7 c: cbrctgc" "\x00"
  "5-16 l: llllxlllllllllllll" "\x00"
  "6-7 c: chxclqcdrh" "\x00"
  "1-10 c: jcmcccccwcccccjbvc" "\x00"
  "8-14 h: zhhvhhhhhhhhhv" "\x00"
  "4-7 n: rnnnnnfnnnnnvn" "\x00"
  "10-12 w: wwwwwwwsgtwww" "\x00"
  "5-8 c: cmbcctzcj" "\x00"
  "5-7 f: fffskrf" "\x00"
  "5-6 l: lllmzl" "\x00"
  "7-14 m: mmmmmmmmmmmmmmmmmmm" "\x00"
  "1-9 f: jfffffffzvffff" "\x00"
  "2-5 g: ggmng" "\x00"
  "16-17 x: xxxxxxxxxxxxxxxlx" "\x00"
  "4-10 n: npkgjcfnnnnn" "\x00"
  "1-13 d: bhkjgsnzxkdgwbdv" "\x00"
  "6-7 f: ncqfzff" "\x00"
  "7-10 h: hqhhhhhjhhh" "\x00"
  "2-4 v: vnvvv" "\x00"
  "1-6 w: thlmdwgwgtswvtx" "\x00"
  "3-7 d: ddlkhvfdnpbdr" "\x00"
  "1-4 q: qbfq" "\x00"
  "2-6 f: rzfmfrjgcfjk" "\x00"
  "10-16 b: bbbbblbbbkbbbbbbwqb" "\x00"
  "13-14 j: jjhcjnkgvrnwjp" "\x00"
  "5-12 l: lgqwvrlwcllllv" "\x00"
  "4-8 j: jjgpdjssspjfdbt" "\x00"
  "1-9 h: hhhhhhhhwhhh" "\x00"
  "4-6 p: psmppt" "\x00"
  "2-3 h: zhhhk" "\x00"
  "2-6 b: bbbbbmbbvb" "\x00"
  "7-9 z: zzzzzzgzdzz" "\x00"
  "8-9 d: ddgdmdwddd" "\x00"
  "2-6 s: nssssv" "\x00"
  "18-20 x: xxxxxxxxxxxxxxxxxvxx" "\x00"
  "9-10 m: dzckmrbhcmwvkcxmlx" "\x00"
  "10-11 v: vwvvvvwvvghvn" "\x00"
  "3-6 d: wcwxddjhnljfntj" "\x00"
  "13-15 v: vvvvvvvvvvvvcvc" "\x00"
  "1-5 x: xxfxfxxkx" "\x00"
  "7-8 w: wqzjzwwwtw" "\x00"
  "2-4 f: flgl" "\x00"
  "3-6 n: ncfngngdnm" "\x00"
  "5-7 k: kdkmbkkkkxk" "\x00"
  "5-6 x: xxvxth" "\x00"
  "5-6 r: rrhhzr" "\x00"
  "4-6 b: bbbrbbbbbmb" "\x00"
  "12-13 q: qqqqqqqqqzqkqp" "\x00"
  "6-14 n: mlbflnrbhlhpdrfln" "\x00"
  "9-12 q: qqqqqqqqqqqwq" "\x00"
  "3-4 k: rkncnbk" "\x00"
  "1-3 j: jjpj" "\x00"
  "8-9 v: vjvczrvvm" "\x00"
  "9-16 m: tmnmmmxmbmmmrtmmr" "\x00"
  "9-11 q: qqqqqzqqsjxq" "\x00"
  "3-5 h: hhhhcs" "\x00"
  "11-12 k: kkkkkkkkkkkvqk" "\x00"
  "11-12 x: xlxxxjjxxxpx" "\x00"
  "1-12 n: nngtnhlnjfnf" "\x00"
  "5-7 p: ppptppppp" "\x00"
  "13-14 l: lllmlflllhllpm" "\x00"
  "13-14 m: vdkmrdfzmkknmp" "\x00"
  "13-15 s: ssssssqssssscssss" "\x00"
  "5-11 h: hhhlxhhhhhhshh" "\x00"
  "10-11 s: ssssssssssgsssss" "\x00"
  "6-7 q: kqqqqmqnqq" "\x00"
  "8-13 l: llllllltlllljll" "\x00"
  "9-12 j: jjjjjjjjjjjlj" "\x00"
  "7-11 s: gstcncsssscssssss" "\x00"
  "4-6 x: lrtjfnhmpmxj" "\x00"
  "9-20 c: cttccccccnccclcccccc" "\x00"
  "1-8 w: cwwwwwwwwww" "\x00"
  "12-13 n: nnnnnnnngnnnnn" "\x00"
  "1-5 p: pfqwcpnppppwwpqppp" "\x00"
  "7-8 g: gggsgglghg" "\x00"
  "6-7 g: gggggggg" "\x00"
  "4-10 s: ssssssssssss" "\x00"
  "1-2 n: njsnnln" "\x00"
  "7-8 z: gzczzwdzkkzz" "\x00"
  "2-8 b: bbbwjfbh" "\x00"
  "6-8 r: rrrrbrrbr" "\x00"
  "2-5 k: lkkkkl" "\x00"
  "2-3 c: swcgjcm" "\x00"
  "2-10 t: ttttttttttt" "\x00"
  "12-13 l: lllllxllllllqhl" "\x00"
  "2-9 l: qtqxdpqqlwhqwlr" "\x00"
  "1-5 q: qqxrn" "\x00"
  "10-11 k: kkkkkkkkkckk" "\x00"
  "1-2 f: ffff" "\x00"
  "3-4 r: rrxr" "\x00"
  "8-9 p: lppppxpsp" "\x00"
  "2-5 s: ssstchlrds" "\x00"
  "11-15 m: mmmmmmmmmmmmmmmmm" "\x00"
  "14-17 k: kkkkkkkkkkgkkkktbkk" "\x00"
  "1-2 x: xlxx" "\x00"
  "9-10 w: wwcwptczwzzd" "\x00"
  "1-3 c: ccgcccccccccccccc" "\x00"
  "4-5 h: nhhhvh" "\x00"
  "8-16 l: hlllfllllmltlhlldl" "\x00"
  "4-5 w: wgwfw" "\x00"
  "6-15 p: pjpbfrmxqgkxkbqhj" "\x00"
  "12-17 l: llmtllnlllllllllnns" "\x00"
  "8-15 n: zjnxzndnznklxzjlx" "\x00"
  "6-9 r: wpsmstnkgtrmng" "\x00"
  "3-7 s: csvhxhsgvrsrn" "\x00"
  "10-15 h: hchhhdhkhghlhgsh" "\x00"
  "2-9 c: mzbmtccktc" "\x00"
  "3-4 x: xlzvxg" "\x00"
  "12-14 k: zmkskknwkkkmkkwkgkkk" "\x00"
  "4-9 r: vqrrrrdzpl" "\x00"
  "3-4 g: ggvbxg" "\x00"
  "5-8 q: xtrqrmqq" "\x00"
  "16-18 l: zllllllllllllllwlnll" "\x00"
  "6-7 s: zsqszss" "\x00"
  "3-4 g: wghgpg" "\x00"
  "1-6 z: hzzzzrz" "\x00"
  "3-8 h: hthfqtccnq" "\x00"
  "15-18 p: ppppppcpppppppnppppp" "\x00"
  "3-4 l: qplkdmjntlghjlpxlq" "\x00"
  "10-12 q: xzqkxdvgrqxqqzzxgjj" "\x00"
  "6-9 q: qqqvsvqqxq" "\x00"
  "12-13 g: shgcnjlgvcgqg" "\x00"
  "5-10 l: llklplllmlsl" "\x00"
  "3-12 l: vllqfzwnsqslpnvrbkh" "\x00"
  "14-16 g: gjggggggggggggbzcggg" "\x00"
  "5-11 m: ssmsmbnspmm" "\x00"
  "11-13 v: mkqvvvvvmcvvz" "\x00"
  "2-3 k: mkkchtzqsvkbclgxn" "\x00"
  "4-7 r: rphrrnrrqwknrktrgsg" "\x00"
  "6-10 z: vpjhzzzkqzjl" "\x00"
  "16-18 c: ccccccccccccccchccc" "\x00"
  "1-10 v: qvvvvzvvvvvv" "\x00"
  "5-7 j: jjrjjjj" "\x00"
  "14-16 l: zlgdrlqllgpllfhh" "\x00"
  "3-6 l: llmllll" "\x00"
  "3-4 l: smdl" "\x00"
  "4-11 h: kgqhcpvrbldrhbq" "\x00"
  "1-15 j: ljjjjjjjjjjjjjjj" "\x00"
  "7-14 c: ccccccccccccccc" "\x00"
  "2-10 v: vzvjvvvvvvvvv" "\x00"
  "4-9 p: flbpmqmhkpt" "\x00"
  "10-12 q: rtdrqmpcsqrhqqchqczw" "\x00"
  "16-19 w: vlwxgtmjwrzvqgdwbdw" "\x00"
  "8-15 c: gkcccslctcmszhc" "\x00"
  "3-7 f: hhffhbbtbwzw" "\x00"
  "4-9 s: msbsxssds" "\x00"
  "13-15 p: pppppppppcpppxldp" "\x00"
  "6-7 m: mmmmmqmm" "\x00"
  "11-12 m: mxmmzwmmmdqpmp" "\x00"
  "7-12 l: gncmgzxlqcllqgt" "\x00"
  "12-14 t: tttttttttttdtt" "\x00"
  "2-6 f: ffffffbrfffp" "\x00"
  "14-17 h: hhdhpphhhhhhkhhxqph" "\x00"
  "7-9 x: xxxxxxxxqxxxxxx" "\x00"
  "5-18 j: vlwgjljtljtrdbxjnjwm" "\x00"
  "5-7 n: jmncnsndnbwx" "\x00"
  "8-9 r: rrrrrrrrr" "\x00"
  "11-17 j: jjjjjjjjjjjjjjpjr" "\x00"
  "5-6 x: xxxxjt" "\x00"
  "13-15 l: nshmnjgzhmjdzvl" "\x00"
  "9-10 r: wmsvzxsrqnnhfr" "\x00"
  "8-11 k: kkkxxrkpktg" "\x00"
  "1-7 r: rrrrrrrfrrrjwrd" "\x00"
  "5-7 t: rztvtvplbrk" "\x00"
  "2-7 w: wwwwwwsw" "\x00"
  "1-2 g: sgggk" "\x00"
  "12-13 j: jjjjjwjjjjvvjjjrjs" "\x00"
  "1-2 c: cccccc" "\x00"
  "3-5 g: khgzr" "\x00"
  "9-16 b: bbbbbbcbsbbbbbbb" "\x00"
  "12-13 z: zzzzzzzzzszkz" "\x00"
  "4-5 r: rkrrrr" "\x00"
  "1-2 t: tgbqtddbmq" "\x00"
  "1-2 w: wkwwwww" "\x00"
  "14-15 q: qqdqqqqqqqqhqnb" "\x00"
  "6-7 r: rrrrrdmrr" "\x00"
  "8-9 j: jjjjjjjqhjjjjj" "\x00"
  "3-6 t: gwmlntffstzllvs" "\x00"
  "6-8 h: hhhhnhhhqh" "\x00"
  "9-11 w: cwcwwwwwgxwwbw" "\x00"
  "5-9 w: wwwwcwwww" "\x00"
  "8-12 k: snjmkkhrgkkzkkpskk" "\x00"
  "3-6 q: lvqjqlq" "\x00"
  "3-4 z: zzzn" "\x00"
  "9-12 t: dvmvhttxtmzhrr" "\x00"
  "3-7 k: kkkkkkskkkkkk" "\x00"
  "6-15 v: vqvvvdvvvvbvvvvvvvvv" "\x00"
  "3-4 z: jzzzzzdk" "\x00"
  "8-12 b: bbbbbbbbbbbs" "\x00"
  "3-9 m: nvhwmwgmmqkbmmmzb" "\x00"
  "8-10 r: npwjcgwrwcrx" "\x00"
  "1-5 r: rxdrr" "\x00"
  "6-9 p: ppppppsbkmppkp" "\x00"
  "1-4 j: jjjqjjjz" "\x00"
  "6-7 b: rblbbbbbbp" "\x00"
  "5-9 t: tttttttttf" "\x00"
  "8-9 c: czcccccccc" "\x00"
  "13-14 j: jjjbjjtbjjjjjj" "\x00"
  "3-8 p: pwppzqvp" "\x00"
  "3-12 m: mmzmmmmmmmmmmm" "\x00"
  "3-9 d: ddjddddddqddd" "\x00"
  "3-4 q: qqfq" "\x00"
  "6-14 m: mmmmmbmmmmwmmlmmmm" "\x00"
  "3-4 c: glgzc" "\x00"
  "6-7 t: ttttttt" "\x00"
  "1-4 s: sssbs" "\x00"
  "5-8 r: drrkrrrzrrrr" "\x00"
  "10-12 q: rvqfqqkllqqqlfrq" "\x00"
  "11-13 s: szsssssssssssss" "\x00"
  "8-11 t: tttttttsttvt" "\x00"
  "11-15 j: zjjjjjjjjjjjjjjjjj" "\x00"
  "2-4 s: dvfs" "\x00"
  "3-4 q: zhpq" "\x00"
  "10-11 c: cccccccccckc" "\x00"
  "5-11 h: pnrjhtdlkzvhh" "\x00"
  "5-9 l: nlllxgnrlllllllmq" "\x00"
  "3-4 f: gfff" "\x00"
  "8-9 g: grgggggbg" "\x00"
  "3-4 j: pfwjhh" "\x00"
  "2-5 l: jlfjr" "\x00"
  "2-4 l: lblv" "\x00"
  "3-10 q: qqvzhnqqhqvqq" "\x00"
  "11-15 t: tfttttttktwttts" "\x00"
  "12-14 b: gqptrzwclbdbfqd" "\x00"
  "1-4 r: crrprr" "\x00"
  "5-13 v: qvdvvvdnrqmrqp" "\x00"
  "9-12 r: rwrrlsrrsrrjgdnrrr" "\x00"
  "4-6 c: ccldccnp" "\x00"
  "16-17 q: qqqqqpqqqqlqqqqmlq" "\x00"
  "2-8 w: wwwwwwwhwmwws" "\x00"
  "3-6 m: dmmbmmdmkxm" "\x00"
  "6-13 t: xflrtblvcvfxnlf" "\x00"
  "2-6 m: pmnsmm" "\x00"
  "13-15 k: kstfvnkkgfvvkbk" "\x00"
  "4-10 w: jqwcwlcwcwvqbfzfzfm" "\x00"
  "1-5 d: ddndbmjxhfqqn" "\x00"
  "13-16 p: pzvbszhqtpklpkpdw" "\x00"
  "2-4 t: thttwmxjsbtp" "\x00"
  "8-10 s: zbsvjcssfmf" "\x00"
  "3-5 l: lltlwlllll" "\x00"
  "12-14 g: hgfvvfpnrvpfggnss" "\x00"
  "3-13 q: cjmbvgxchmqdqcvc" "\x00"
  "12-16 j: cjjjjjjjjjjqjjjjjj" "\x00"
  "1-5 m: kqrgm" "\x00"
  "11-14 x: xcjpwbrrffxkfxh" "\x00"
  "12-14 c: kgfnccxqczkcjkcc" "\x00"
  "3-4 f: sfftf" "\x00"
  "1-3 f: ffdz" "\x00"
  "12-14 t: xftfxmkttdsttg" "\x00"
  "4-9 f: ffhcgfffffff" "\x00"
  "9-10 b: zjlbbsbzbx" "\x00"
  "9-14 m: hhxmlmmmzmmtmm" "\x00"
  "3-5 t: tkcpzjwr" "\x00"
  "6-9 k: wkfdwflgrntrknsr" "\x00"
  "1-4 l: gfml" "\x00"
  "9-10 z: zzzzzzzzzrzzzz" "\x00"
  "9-11 h: hhhhhhhhhhzhh" "\x00"
  "1-9 k: kkkkkkkkzkkkkkkk" "\x00"
  "2-7 h: sswmmkhkvhw" "\x00"
  "2-5 m: pmbnnmzrkk" "\x00"
  "9-12 f: xhpfbfdffkfw" "\x00"
  "3-4 g: gfwg" "\x00"
  "11-12 n: nnnnnnnnnnnpnnnxn" "\x00"
  "5-6 d: dddddgddd" "\x00"
  "7-9 j: cbjgnjqjgj" "\x00"
  "9-14 r: rrrrrrrhrrrrrzbrr" "\x00"
  "4-5 p: prphk" "\x00"
  "2-4 d: dpdd" "\x00"
  "5-15 p: zjsppzhqqgqspcppqpps" "\x00"
  "2-7 r: rrrrrrfwrr" "\x00"
  "1-3 h: hhqh" "\x00"
  "14-16 g: zgvdgspkjrrvcgdlxg" "\x00"
  "4-6 c: psgqccccvc" "\x00"
  "9-14 q: qdqjqmttdtcqggqpqn" "\x00"
  "13-18 f: ffffffffffffgffffff" "\x00"
  "8-9 g: gggggggggggg" "\x00"
  "11-12 x: xxxxxxxxxxxr" "\x00"
  "2-17 c: cxcccfchcccccccbbcm" "\x00"
  "7-11 b: nwbrzndvrfxwt" "\x00"
  "3-4 x: xhwxxxv" "\x00"
  "16-17 r: rzrrnrrrvxrrzrrrrrr" "\x00"
  "2-3 f: zcvgbmxvwp" "\x00"
  "5-6 b: fwbbbf" "\x00"
  "6-10 m: mmmmmpmmmw" "\x00"
  "2-4 n: bnnvndbpvzj" "\x00"
  "3-4 t: dftfhdngqp" "\x00"
  "1-2 v: vtvvvvvvvvv" "\x00"
  "2-3 v: vgvv" "\x00"
  "9-10 s: tsvsshsssgssssmsksss" "\x00"
  "6-7 t: ttttttxt" "\x00"
  "3-4 c: jcrc" "\x00"
  "5-8 l: ztlmjljlb" "\x00"
  "4-5 w: bwwwww" "\x00"
  "11-14 r: rrrbrrrrrrnrrrs" "\x00"
  "10-16 z: zzzzznzzzwzzzzzzzz" "\x00"
  "7-13 m: mmmmmmfmmmmmmmmmmmmm" "\x00"
  "15-19 w: fflzcwftmcswcwwnwts" "\x00"
  "10-19 b: bjbbbbbbmwbbbbbbbbtb" "\x00"
  "14-16 x: xxxxpxxpxxqxdqxxxx" "\x00"
  "8-13 r: rkzrjbxrgwkhnb" "\x00"
  "5-18 r: rrrzfkrrrrrrrrtrrnrr" "\x00"
  "4-5 b: bbbfzb" "\x00"
  "6-10 q: qnscxqqfqb" "\x00"
  "8-13 w: wwwwwwwfwwwwwwwwww" "\x00"
  "10-11 n: scvnsnpgnjnmdpnwct" "\x00"
  "7-11 p: pjpppppdqpjpfppsptp" "\x00"
  "7-9 n: jfsvclhfm" "\x00"
  "3-8 h: whsggqscd" "\x00"
  "2-12 r: mrmpxhrqsdmqpjshvck" "\x00"
  "2-4 g: gdgggg" "\x00"
  "7-12 s: ssssssssgsss" "\x00"
  "7-11 l: dlklllnjlslbl" "\x00"
  "5-11 k: kkkkkkkkkkkkkkk" "\x00"
  "6-9 g: dhtvcgmfrjhk" "\x00"
  "4-5 m: lmmmhmsmmmmmcmmmmzmm" "\x00"
  "11-13 t: zgtnkjzmtkttmtkc" "\x00"
  "6-7 b: bbbbbbv" "\x00"
  "3-4 q: qqcq" "\x00"
  "12-16 z: zzzszjzszzczmxtzzcl" "\x00"
  "2-5 w: wwfhp" "\x00"
  "1-2 d: gddkd" "\x00"
  "5-12 f: fwqgbvrcfmwb" "\x00"
  "2-5 w: bnxcw" "\x00"
  "3-15 t: ncwftppphsxvztttjs" "\x00"
  "7-10 p: ppnsppkcppsp" "\x00"
  "5-6 v: vvrdvv" "\x00"
  "5-6 z: hczwbzz" "\x00"
  "3-12 p: gcphfgmzfkflspmxg" "\x00"
  "14-19 m: jmfmfjpvbmfmmrdkdnzp" "\x00"
  "6-7 p: pdwzppppp" "\x00"
  "4-7 b: bbbnbbqbb" "\x00"
  "7-8 r: frrrrrxxr" "\x00"
  "8-18 b: jbphpzgvnppwhkxfzs" "\x00"
  "1-5 c: pvhcc" "\x00"
  "4-8 z: fzznzjzztstzxrz" "\x00"
  "5-10 v: jvvwvvvlvlvqc" "\x00"
  "7-14 p: svgrzfpxkdpbhph" "\x00"
  "5-7 n: nncmvkn" "\x00"
  "11-12 r: rrlrbrrrvrrr" "\x00"
  "1-5 r: vtngrndhqf" "\x00"
  "2-4 k: knjp" "\x00"
  "11-14 h: hhghhhhhhhxhhwhhh" "\x00"
  "16-18 r: rrrrrrrrrrrrrrrpnb" "\x00"
  "10-14 d: dpddbvdtdmxfdddd" "\x00"
  "2-4 t: cztt" "\x00"
  "5-6 r: rzrprd" "\x00"
  "2-5 n: ngwdngc" "\x00"
  "1-6 q: qqqzzwwqqqkqqq" "\x00"
  "7-8 l: lllzllpxl" "\x00"
  "1-4 b: kmltzzjzbppgwq" "\x00"
  "1-4 t: ttttb" "\x00"
  "3-4 p: dkxpcph" "\x00"
  "7-15 z: zzzzzzhzzzzzzzzzz" "\x00"
  "4-7 c: cdljfccm" "\x00"
  "3-8 p: hbpxhlmc" "\x00"
  "4-5 w: wwwlw" "\x00"
  "14-15 b: lbqbbbkgbbwfbdb" "\x00"
  "6-10 j: jtjjvpwwthwcsj" "\x00"
  "5-8 t: ltvtttbtqxtzq" "\x00"
  "12-13 t: ttttttttjttztxt" "\x00"
  "16-18 p: ppppppppppppppxpxbpp" "\x00"
  "4-7 n: nnnrnnnnt" "\x00"
  "1-2 r: rfrr" "\x00"
  "5-6 g: ggggvggg" "\x00"
  "3-4 s: ssbw" "\x00"
  "3-4 l: ldll" "\x00"
  "8-10 m: mmmmvmmcjkmg" "\x00"
  "10-18 w: wwvwwvwwhwwjwwwlwxcm" "\x00"
  "1-2 x: cxxxxxxxxxxxxx" "\x00"
  "1-5 b: bbbbkbbb" "\x00"
  "12-14 z: zwqzrrzzvqqzzszrx" "\x00"
  "1-5 z: lzzfzzzfz" "\x00"
  "16-17 t: ftgstrgptwmptxrzt" "\x00"
  "9-10 b: bbbbbbbzbbbb" "\x00"
  "8-14 w: wwwwwwwjwwwzwzww" "\x00"
  "3-4 h: qhnh" "\x00"
  "2-12 d: dnddddkddddzdxdddd" "\x00"
  "5-17 x: xxxxxxxxxxxxxxxxx" "\x00"
  "9-10 h: hhhhtqhhhrh" "\x00"
  "6-7 p: pfmppppp" "\x00"
  "5-8 v: vbvvvvvs" "\x00"
  "4-5 h: qhfhqcb" "\x00"
  "3-12 d: dlddlhhwvcrdrxwpt" "\x00"
  "2-3 n: nnwnp" "\x00"
  "4-8 g: ggggjgfgzgdglgg" "\x00"
  "4-9 h: vrghsphxhxzsxw" "\x00"
  "12-18 z: qrzzzfwdcwnzdzkckz" "\x00"
  "6-8 v: zvmlqwwh" "\x00"
  "10-14 p: pppxwpndfpwppdpptmpp" "\x00"
  "12-15 q: qqnqkqkqjgrcqfq" "\x00"
  "2-4 n: pnszjnnn" "\x00"
  "2-3 c: zkctcfc" "\x00"
  "17-20 l: lvjlcclllslzllllwgll" "\x00"
  "16-17 k: dfgskkfkkkfjhfvfks" "\x00"
  "1-3 t: tjttltt" "\x00"
  "2-3 b: bbzbb" "\x00"
  "8-15 t: dtttttsttlttttzlttj" "\x00"
  "13-14 v: vvkvvjvgwvvvkvf" "\x00"
  "7-8 v: tvvvvvvhv" "\x00"
  "3-10 d: bxktdrtddtdtsh" "\x00"
  "4-12 j: npwxjjjjbjkq" "\x00"
  "1-4 l: tlllll" "\x00"
  "12-13 b: lbhpxbbbvbbbqbbbsbb" "\x00"
  "9-15 v: vqhsggmpvmqtbzzlq" "\x00"
  "12-14 f: ffhfjfffqfxqff" "\x00"
  "15-16 m: jtnsjwpggbpxlhqmk" "\x00"
  "2-4 n: xptncjsstcl" "\x00"
  "5-8 q: dmwklqjqnzb" "\x00"
  "3-4 c: vcgl" "\x00"
  "1-6 h: hhhhhh" "\x00"
  "8-9 x: ckblstcdx" "\x00"
  "5-7 w: vwphwwmwwwww" "\x00"
  "2-4 x: kxxxdh" "\x00"
  "10-11 m: kmmvmmmfmksmj" "\x00"
  "4-7 v: zvrvvvdvvv" "\x00"
  "1-8 p: npxbwqpxbjrnrv" "\x00"
  "5-11 t: jfkwttkstrxlgts" "\x00"
  "1-2 g: ggggg" "\x00"
  "5-7 p: tpppppr" "\x00"
  "15-17 v: vvvvvvvvvvvvvvvvvvvv" "\x00"
  "17-19 w: dwjwjznczwgfmkmhdtw" "\x00"
  "10-13 f: fffffbqfffffffffff" "\x00"
  "4-14 g: ggggggggggggggg" "\x00"
  "2-3 d: bdkfd" "\x00"
  "7-8 x: xxxxxxxx" "\x00"
  "6-9 h: hmshdhvvhkhbhcshs" "\x00"
  "14-15 g: gggggggggggggghg" "\x00"
  "2-16 q: qqsxqqqdgqqghqqk" "\x00"
  "3-17 p: ppbppprppppppppphppp" "\x00"
  "8-18 v: vczfvqcvvcspndvxwjdv" "\x00"
  "1-3 d: fdddd" "\x00"
  "9-11 j: gfjjnjsdnhb" "\x00"
  "8-10 s: hkhshttssl" "\x00"
  "5-10 f: ffsffffffqxfff" "\x00"
  "7-10 w: wwlwwckwwf" "\x00"
  "4-8 x: blxxmtbgnblfgnfwz" "\x00"
  "4-5 p: rlpkprppp" "\x00"
  "13-14 s: ssssssssssssswss" "\x00"
  "4-8 h: hhhdhmhhhjhlhh" "\x00"
  "6-7 h: chhhhhfhzqhdhhh" "\x00"
  "15-17 m: msvrmwzkzvmmgrmmpm" "\x00"
  "4-6 x: qgtwwxhgsxxmklgmn" "\x00"
  "4-7 p: rpzkdpp" "\x00"
  "3-4 v: vvvhvjv" "\x00"
  "16-18 p: pppppppppppppppppmp" "\x00"
  "15-17 k: kpkkkkkhqkkkkklktk" "\x00"
  "5-7 s: ssbxxsk" "\x00"
  "2-4 l: cwllll" "\x00"
  "6-9 v: cvvrrkvrvsdvfwcv" "\x00"
  "1-7 w: qwwwwslwwwwwwwwrww" "\x00"
  "2-12 c: clcccccccccccccc" "\x00"
  "5-10 m: ftcmrpmvrzc" "\x00"
  "7-11 w: wwwwwwwwwwtwwwww" "\x00"
  "2-3 n: jngdlvgcvtkmn" "\x00"
  "1-8 v: hvvvvvvvvv" "\x00"
  "3-17 p: jrpvltxlcqgpfxwsj" "\x00"
  "1-5 k: kkkkfkk" "\x00"
  "1-10 c: cccccccccfc" "\x00"
  "13-19 f: flfffffxfvffffprfmcb" "\x00"
  "3-6 g: htglsbvrzcghjmd" "\x00"
  "9-11 h: wrwghhhhnzhxl" "\x00"
  "5-12 z: zzkzzhnjpmkvzzzw" "\x00"
  "7-11 w: qrwcwwstwddw" "\x00"
  "15-19 m: mmmmmmmmmmmmmmmmmmmm" "\x00"
  "15-16 m: mmmmmmmmmmmmmmhmm" "\x00"
  "12-16 x: xxxxxcxxxxxlxxxxxxx" "\x00"
  "5-10 l: qwfqlllgsdjrlspll" "\x00"
  "3-4 f: hffmfffg" "\x00"
  "6-7 l: lwlllbllnl" "\x00"
  "11-20 t: tttkrtlpttwftmwttttt" "\x00"
  "11-12 d: ddbdddddddpktdd" "\x00"
  "4-11 w: sxkmkwdwwnlwxmdvfx" "\x00"
  "4-5 k: kkzkpk" "\x00"
  "13-20 n: nnnnnntnnnnnbnnnbnnn" "\x00"
  "5-7 c: ccccwcc" "\x00"
  "1-6 h: cckkhhdhhwmhhmzchhwx" "\x00"
  "1-15 b: hbbbbbbbbhbbhbbbbnbb" "\x00"
  "1-2 w: mwwww" "\x00"
  "1-2 f: sfzgwtf" "\x00"
  "3-4 s: sssj" "\x00"
  "1-3 w: xwww" "\x00"
  "1-16 p: ppppppppdppppppp" "\x00"
  "1-6 c: ccxmccccc" "\x00"
  "4-8 b: rtpbcfbr" "\x00"
  "9-10 s: sszssstshss" "\x00"
  "15-16 x: xxxtxxxxxxxmxxxzx" "\x00"
  "9-15 k: kkkkkkkkkkgrkkkkk" "\x00"
  "11-13 x: xtxxxxxxxxrxkxx" "\x00"
  "1-5 f: rffflfffnf" "\x00"
  "14-16 n: nnxnnnnnnnnnbnzbnnn" "\x00"
  "3-6 d: ddddddndbdfdhd" "\x00"
  "14-15 q: sbqqhvqqqvqgxfq" "\x00"
  "5-6 b: jglbfjb" "\x00"
  "1-10 l: llllllcllsll" "\x00"
  "3-5 z: lwzzz" "\x00"
  "5-12 k: kkkkmkkkkkkkkkkl" "\x00"
  "8-12 v: vvtsvfvnzvhpm" "\x00"
  "5-7 l: llllllll" "\x00"
  "4-7 f: nqfffkbdf" "\x00"
  "4-8 j: jjjljkhj" "\x00"
  "9-15 h: vgzpgfhfhmwdhbqc" "\x00"
  "1-5 p: ptpsjqpnp" "\x00"
  "5-8 q: qbqqwqnq" "\x00"
  "5-7 w: wwswwxsb" "\x00"
  "3-6 h: nnhrnhkmxqkt" "\x00"
  "1-3 w: jwwww" "\x00"
  "2-14 x: cxxxxdxxxxxxxbxx" "\x00"
  "12-14 x: xxxfxxxxqxxrxt" "\x00"
  "4-9 f: fffkffbsfkxv" "\x00"
  "12-13 m: mmmmmmmmmmmwm" "\x00"
  "6-10 p: ppppphpppxppp" "\x00"
  "9-12 v: vsvvvvkmjvvvn" "\x00"
  "3-12 r: shngvhbmjrpr" "\x00"
  "12-13 w: wqwcwxclwwwfw" "\x00"
  "4-5 r: nnrrdz" "\x00"
  "4-19 c: vbcpwzvxssccqkqgmxvj" "\x00"
  "1-6 g: tglxhggng" "\x00"
  "9-10 z: lvzhvtglzf" "\x00"
  "10-16 f: gddxfftggfbmxwts" "\x00"
  "4-12 k: kkkklkkkkkkpkkk" "\x00"
  "7-11 m: mmmmmmmmmmtm" "\x00"
  "2-10 z: vkfpjrrvlwlbjwk" "\x00"
  "3-7 w: dtdzwjqgxdwjhchwwd" "\x00"
  "13-14 v: vvvvvvvvvvvvvvvv" "\x00"
  "11-12 c: cjccccqccccc" "\x00"
  "14-15 h: hzhrhkhfthrhxht" "\x00"
  "3-5 v: dtwvvvvvcvvvrvsvvv" "\x00"
  "10-14 q: qhqqkqcqqqqqlfqgsqq" "\x00"
  "3-14 f: ffvffffffffzffffff" "\x00"
  "1-12 x: xxtxjxzxxxxxlxxxxxxx" "\x00"
  "2-4 c: pgpc" "\x00"
  "1-4 r: fdrr" "\x00"
  "5-7 r: rrrrrrt" "\x00"
  "10-11 d: drdddddddmddddpd" "\x00"
  "2-5 f: gfrlctftzr" "\x00"
  "10-13 z: nrzjjrzjzzplzmzzbn" "\x00"
  "8-10 c: cccccccgbc" "\x00"
  "5-8 g: fgggcndwgggbjnfgb" "\x00"
  "6-9 d: ddddghdgbddm" "\x00"
  "3-7 j: ftjjjvjqcp" "\x00"
  "5-6 s: sqvfstz" "\x00"
  "5-18 k: kkkwkkkkkkbkkkkkkkbk" "\x00"
  "3-6 f: djffffkff" "\x00"
  "4-6 p: pqppppr" "\x00"
  "5-9 h: hhkhjhmgcqvfhqvhn" "\x00"
  "8-12 t: tttttttvttttt" "\x00"
  "14-15 z: pzrzhjqmtbcnzdzr" "\x00"
  "1-17 s: ssssssssssssswsss" "\x00"
  "1-4 s: ssqh" "\x00"
  "1-5 r: rrrrrrr" "\x00"
  "17-18 h: hhhhhrhcxhhhhhhhhb" "\x00"
  "7-9 t: dttttjmtv" "\x00"
  "1-3 c: mcccp" "\x00"
  "4-5 x: xprbxql" "\x00"
  "1-5 q: cqqqqqq" "\x00"
  "3-4 g: ggggw" "\x00"
  "1-7 f: ffffffnf" "\x00"
  "7-9 t: ttttttttttt" "\x00"
  "11-15 m: mmlmfmmmmmmmmmmqm" "\x00"
  "4-5 n: npnnnn" "\x00"
  "4-5 b: zvbbvbjhlkf" "\x00"
  "11-16 c: gnqmcvtzwpcbvncwcc" "\x00"
  "12-18 q: qbqkwqqvqwqqnljsqpqt" "\x00"
  "6-10 r: wcrtdrlkgjr" "\x00"
  "16-17 p: gppppppppwvlgpptp" "\x00"
  "1-13 g: gqghbwqqzwwdk" "\x00"
  "1-6 l: rlllll" "\x00"
  "3-7 j: pdjjtcqwbqtpfkjbwgq" "\x00"
  "7-17 z: zzhsnjrhrzzfrqszdhdg" "\x00"
  "6-7 n: xnvnhnrn" "\x00"
  "6-7 r: rrrrrrzr" "\x00"
  "2-3 c: ccmcccc" "\x00"
  "2-3 v: vvdv" "\x00"
  "3-9 f: mlfffshbfdff" "\x00"
  "11-13 v: dfvkltvjvvvvx" "\x00"
  "12-13 c: mqrccccbccbgcccccvc" "\x00"
  "9-13 w: wwwwwwwwwwwwcwtww" "\x00"
  "6-8 d: pdvgddtmvwdkvdtzf" "\x00"
  "1-9 s: hsssssssssdsls" "\x00"
  "1-5 c: zbsslcd" "\x00"
  "1-4 p: bpppppppppp" "\x00"
  "13-16 s: sssxslsscssbqsspcs" "\x00"
  "1-10 p: pskwpppzpppppks" "\x00"
  "3-5 c: ccppccmcc" "\x00"
  "10-11 b: rhbbbbbbbzbb" "\x00"
  "2-3 d: ndhjhd" "\x00"
  "3-4 s: sscs" "\x00"
  "5-6 d: dtwwnt" "\x00"
  "4-5 d: dddddddd" "\x00"
  "5-9 z: zztzvzzzz" "\x00"
  "2-6 v: vpqdll" "\x00"
  "13-14 d: nxkmbkkpxkcdld" "\x00"
  "1-3 s: ssss" "\x00"
  "8-14 z: zzzzzzzzzzzzzbz" "\x00"
  "16-17 f: fffnffffffftbzffpkf" "\x00"
  "3-4 m: mtcm" "\x00"
  "3-4 r: mrdrd" "\x00"
  "11-13 k: ljkmhdkkkcpjzlmkkzkk" "\x00"
  "2-3 d: tdqnxpd" "\x00"
  "3-7 h: mrvdlthxchpvwvssqpk" "\x00"
  "13-17 j: jjfjjvjjjjjzjsjjksxr" "\x00"
  "1-4 n: rnnx" "\x00"
  "7-10 m: mmmmzmxfmm" "\x00"
  "1-6 r: lrrvrrrrm" "\x00"
  "4-18 r: rrrdrrrrrrrrrkblrr" "\x00"
  "6-7 k: kkkkkkl" "\x00"
  "4-6 v: vmnfvvvvmcmlh" "\x00"
  "6-9 g: jgcgggkbbmgbs" "\x00"
  "7-8 t: ttcfwtgjtcttv" "\x00"
  "3-4 j: tjjj" "\x00"
;